if not Recount then return end
local Recount = Recount

RecountCC = LibStub("AceAddon-3.0"):NewAddon("RecountCC", "AceEvent-3.0")
local mod = RecountCC

local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")

-------------------------------------------------------------------------
-- LOCALES
-------------------------------------------------------------------------

local DetailTitles={}
DetailTitles.CCHow={
	TopNames = RL["Ability Name"],
	TopCount = "",
	TopAmount = RL["Count"],
	BotNames = "",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = RL["Count"]
}

local SN = setmetatable({}, {__index = function(t, k)
	local n = GetSpellInfo(k)
	rawset(t, k, n)
	return n
end})

local cc = {
	-- Death Knight
	47476, -- Strangulate
	49203, -- Hungering Cold
	-- Druid
	339, -- Entangling Roots
	5211, -- Bash
	2637, -- Hibernate
	33786, -- Cyclone
	-- Hunter
	19503, -- Scatter Shot
	1499, -- Freezing Trap
	60192, -- Freezing Trap, Trap Launcher
	19385, -- Wyvern Sting
	-- Mage
	118, -- Polymorph
	61305, -- Polymorph Black Cat
	28272, -- Polymorph Pig
	61721, -- Polymorph Rabbit
	61780, -- Polymorph Turkey
	28271, -- Polymorph Turtle
	82677, -- Ring of Frost
	31661, -- Dragon's Breath
	44572, -- Deep Freeze
	-- Paladin
	853, -- Hammer of Justice
	10326, -- Turn Evil
	20066, -- Repentance
	-- Priest
	8122, -- Psychic Scream
	9484, -- Shackle Undead
	605, -- Mind Control
	15487, -- Silence
	64044, -- Psychic Horror
	-- Rogue
	6770, -- Sap
	408, -- Kidney Shot
	2094, -- Blind
	76577, -- Smoke Bomb
	51722, -- Dismantle
	-- Shaman
	76780, -- Bind Elemental
	51514, -- Hex
	-- Warlock
	5782, -- Fear
	5484, -- Howl of Terror
	-- Warrior
	676, -- Disarm
	5246, -- Initmidating Shout
	85388, -- Throwdown
	12809, -- Concussion Blow
}

local function isCC(spellID)
	for k, v in ipairs(cc) do
		if spellID == v then
			return true
		end
	end
	return false
end

function mod:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function mod:AddCC(spellID, sourceName)
	if not Recount.db2.combatants[sourceName] then
		Recount:DPrint("No source combatant!")
	else
		local sourceData = Recount.db2.combatants[sourceName]
		local sourceName = sourceData.Name
		Recount:AddAmount(sourceData, "CrowdControl", 1)
		local name = SN[spellID] or ""
		Recount:AddTableDataStats(sourceData, "CCHow", name, sourceName, 1)
	end
end

function mod:COMBAT_LOG_EVENT_UNFILTERED(_,_, event, _, sourceGUID, sourceName, _, _, destGUID, destName, _, _, spellID, ...)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" then
		if isCC(spellID) then
			mod:AddCC(spellID, sourceName)
		end
	end
end

function mod:DataModesCC(data, num)
	if not data then return 0 end
	if num==1 then
		return (data.Fights[Recount.db.profile.CurDataSet].CrowdControl or 0)
	else
		return (data.Fights[Recount.db.profile.CurDataSet].CrowdControl or 0), {{data.Fights[Recount.db.profile.CurDataSet].CCHow,"'s CCs",DetailTitles.CCHow}}
	end
end

function mod:TooltipFuncsCC(name, data)
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData(RL["Top 3"].." ".."Crowd Controls",data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].CCHow,3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end

Recount:AddModeTooltip("CrowdControl",RecountCC.DataModesCC,RecountCC.TooltipFuncsCC,nil,nil,nil,nil)
